<template>
  <div class="user-form">
      <h2>User Info</h2>
      <form>
          <div class="first-name-input">
              <label for="first-name">First Name</label>
              <input
                  id="first-name"
                  type="text"
                  :value="userName.firstName"
                  @input="setFirstName"
                  pattern="[a-zA-Z]+"
              >
          </div>
          <div class="last-name-input">
              <label for="last-name">Last Name</label>
              <input
                      id="last-name"
                      type="text"
                      :value="userName.lastName"
                      @input="setLastName"
                      pattern="[a-zA-Z]+"
              >
          </div>
          <button class="button submit" @click.prevent="handleSubmit">Submit</button>
      </form>
  </div>
</template>


<script>

export default {
    name: "UserForm",
    // props: ['modelValue', 'firstName', 'lastName'],
    // emits: ['update:firstName', 'update:lastName'],
    computed: {
        userName(){
            return this.$store.state.userName;
        }
    },
    data(){
      return {
      }
    },
    methods: {
        setLastName($event){
            this.$store.commit('setLastName', $event.target.value);
        },
        setFirstName($event){
            console.log(`We are in the setFirstName method! ${event.target.value}`);
            this.$store.commit('setFirstName', $event.target.value);
        },
        handleSubmit(){
          if(this.userName.firstName.length > 2 && this.userName.lastName.length > 2){
            this.$router.push('cats');
          }
          else{
            alert('Please enter more characters');
          }
        }
    }
}

</script>

<style scoped>

.user-form{
  border: 1px solid black;
  margin: 25px 50px;
  padding: 10px;
  border-radius: 5px;
}

.first-name-input, .last-name-input{
  display: flex;
  flex-direction: column;
  margin: 10px;
  font-size: 12px;
  color: slategray;
}

h2{
  text-align: center;
}

form{
  display: flex;
  justify-content: center;
  margin-bottom: 20px;
}

input{
  width: 150px;
  height: 25px;
  border-radius: 5px;
}

.submit{
  margin-top: 24px;
  height: 30px;
}

label{
  font-size: 14px;
}

</style>